package com.ffcs.ebp.ebpsdk.security;

import java.io.UnsupportedEncodingException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.KeyGenerator;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.SecretKey;
import javax.crypto.spec.SecretKeySpec;

public abstract class DESCoder {
   public static byte[] encrypt(String content, String password) {
      try {
         KeyGenerator kgen = KeyGenerator.getInstance("AES");
         kgen.init(128, new SecureRandom(password.getBytes()));
         SecretKey secretKey = kgen.generateKey();
         byte[] enCodeFormat = secretKey.getEncoded();
         SecretKeySpec key = new SecretKeySpec(enCodeFormat, "AES");
         Cipher cipher = Cipher.getInstance("AES");
         byte[] byteContent = content.getBytes("utf-8");
         cipher.init(1, key);
         byte[] result = cipher.doFinal(byteContent);
         return result;
      } catch (NoSuchAlgorithmException var9) {
         var9.printStackTrace();
      } catch (NoSuchPaddingException var10) {
         var10.printStackTrace();
      } catch (InvalidKeyException var11) {
         var11.printStackTrace();
      } catch (UnsupportedEncodingException var12) {
         var12.printStackTrace();
      } catch (IllegalBlockSizeException var13) {
         var13.printStackTrace();
      } catch (BadPaddingException var14) {
         var14.printStackTrace();
      }

      return null;
   }

   public static String decrypt(String seed, byte[] encrypted) throws Exception {
      byte[] rawKey = seed.getBytes();
      byte[] result = decrypt(rawKey, encrypted);
      return new String(result);
   }

   private static byte[] decrypt(byte[] raw, byte[] encrypted) throws Exception {
      SecretKeySpec skeySpec = new SecretKeySpec(raw, "AES");
      Cipher cipher = Cipher.getInstance("AES");
      cipher.init(2, skeySpec);
      byte[] decrypted = cipher.doFinal(encrypted);
      return decrypted;
   }

   public static byte[] decrypt(byte[] content, String password) {
      try {
         KeyGenerator kgen = KeyGenerator.getInstance("AES");
         kgen.init(128, new SecureRandom(password.getBytes()));
         SecretKey secretKey = kgen.generateKey();
         byte[] enCodeFormat = secretKey.getEncoded();
         SecretKeySpec key = new SecretKeySpec(enCodeFormat, "AES");
         Cipher cipher = Cipher.getInstance("AES");
         cipher.init(2, key);
         byte[] result = cipher.doFinal(content);
         return result;
      } catch (NoSuchAlgorithmException var8) {
         var8.printStackTrace();
      } catch (NoSuchPaddingException var9) {
         var9.printStackTrace();
      } catch (InvalidKeyException var10) {
         var10.printStackTrace();
      } catch (IllegalBlockSizeException var11) {
         var11.printStackTrace();
      } catch (BadPaddingException var12) {
         var12.printStackTrace();
      }

      return null;
   }

   public static void main(String[] args) {
   }
}
