package com.ffcs.ebp.ebpsdk.security;

import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;

public class RandomFactory {
   private static SecureRandom r = null;

   public static final SecureRandom getInstance() {
      if (r == null) {
         try {
            r = SecureRandom.getInstance("SHA1PRNG");
         } catch (NoSuchAlgorithmException var1) {
            var1.printStackTrace();
         }
      }

      return r;
   }

   public static int nextInt(int code) {
      return getInstance().nextInt(code);
   }

   public static int nextInt() {
      return getInstance().nextInt();
   }

   public static double nextDouble() {
      return getInstance().nextDouble();
   }
}
